unit HKUnzip;

interface
uses ZipRead,Unzip,classes,windows,sysutils;

Procedure GetZipContents(Const ZipFile : String; ZipContents : TStrings);
Procedure UnzipContents(Const ZipFile,DestDir : String);
Function IsAZip(Const ZipFile : String) : Boolean;

implementation

function DirectoryExists(const Name: string): Boolean;
var
  Code: Integer;
begin
  Code := GetFileAttributes(PChar(Name));
  Result := (Code <> -1) and (FILE_ATTRIBUTE_DIRECTORY and Code <> 0);
end;

procedure ForceDirectories(Dir: string);
begin
  if Length(Dir) = 0 then Exit;
    Delete(Dir, Length(Dir), 1);
  if (Length(Dir) < 3) or DirectoryExists(Dir) or
    (ExtractFilePath(Dir) = Dir) then Exit;
  ForceDirectories(ExtractFilePath(Dir));
  CreateDir(Dir);
end;

Function IsAZip(Const ZipFile : String) : Boolean;
begin
 result:=iszip(pchar(Zipfile));
end;

Procedure GetZipContents(Const ZipFile : String; ZipContents : TStrings);
var rc:integer;
 ZPRec : TPackRec;
begin
 if not iszip(pchar(Zipfile)) then exit;
 Fillchar(ZPrec,sizeof(ZPrec),0);
 rc:=GetFirstInZip(PChar(ZipFile),ZPRec);
 while rc=zip_ok do begin
  ZipContents.AddObject(ZPrec.Filename,TObject(zprec.headeroffset));
  rc:=GetNextInZip(ZPrec);
 end;
 CloseZipFile(ZPrec);
end;

Procedure UnzipContents(Const ZipFile,DestDir : String);
var sl : TStringList;
a:integer; s:string;
begin
 sl:=TStringList.Create;
 sl.sorted:=false;
 try
  ForceDirectories(Destdir);
  GetZipContents(Zipfile,sl);
  if sl.count=0 then exit;
  for a:=0 to sl.count -1 do begin
   s:=DestDir+sl.Strings[a];
   if s[length(s)]='\' then ForceDirectories(s) else
   UnZipFile(pchar(ZipFile),pchar(s),0,
    Integer(sl.objects[a]),0,0);
  end;
 Finally
  sl.free;
 end;
end;

end.
